#if defined(__linux__)
#if defined(__i386__)

/*
 * Use Linux system call.
 */

#define SYS_exit   1
#define SYS_read   3
#define SYS_write  4
#define SYS_open   5
#define SYS_close  6
#define SYS_ioctl 54

	.section .text

	.globl	___exit
	.type	___exit, @function
___exit:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_exit, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__read
	.type	__read, @function
__read:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_read, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__write
	.type	__write, @function
__write:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_write, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__open
	.type	__open, @function
__open:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_open, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__close
	.type	__close, @function
__close:
	push	%ebx
	mov	0x8(%esp), %ebx
	mov	$SYS_close, %eax
	int	$0x80
	pop	%ebx
	ret

	.globl	__ioctl
	.type	__ioctl, @function
__ioctl:
	push	%ebx
	mov	0x10(%esp), %edx
	mov	0xc(%esp), %ecx
	mov	0x8(%esp), %ebx
	mov	$SYS_ioctl, %eax
	int	$0x80
	pop	%ebx
	ret
#endif
#endif
