#ifndef __NLLIBC_SYS_IOCTL_H_INCLUDED__
#define __NLLIBC_SYS_IOCTL_H_INCLUDED__

int ioctl(int fd, unsigned long request, ...);

#if defined(__FreeBSD__) || defined(__OpenBSD__) || defined(__NetBSD__) || defined(__DragonFly__) || defined(__APPLE__)
#define TIOCGETA  0x402c7413
#define TIOCSETA  0x802c7414
#define TIOCSETAW 0x802c7415
#define TIOCSETAF 0x802c7416
#endif

#if defined(__linux__)
#if defined(__PPC__)
#define TCGETS  0x402c7413
#define TCSETS  0x802c7414
#define TCSETSW 0x802c7415
#define TCSETSF 0x802c7416
#else
#define TCGETS  0x5401
#define TCSETS  0x5402
#define TCSETSW 0x5403
#define TCSETSF 0x5404
#endif
#endif

#endif
